package ru.nsu.fit.mustakov.graphics;

import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Point2D;

public class GraphicsUtilities {
    public static void drawLine(Graphics2D g2, Point2D first, Point2D second) {
        double dx = first.getX() - second.getX();
        double dy = first.getY() - second.getY();
        Point2D current = first;
        g2.draw(new Pixel(current));
        while (Math.abs(dx) > 1 || Math.abs(dy) > 1) {
            if (Math.abs(dx) > Math.abs(dy)) {
                if (dx > 0) {
                    current = new Point.Double(current.getX() - 1, current.getY());
                }
                else {
                    current = new Point.Double(current.getX() + 1, current.getY());
                }
            }
            else {
                if (dy > 0) {
                    current = new Point.Double(current.getX(), current.getY() - 1);
                }
                else {
                    current = new Point.Double(current.getX(), current.getY() + 1);
                }
            }
            g2.draw(new Pixel(current));
            dx = current.getX() - second.getX();
            dy = current.getY() - second.getY();
        }
        g2.draw(new Pixel(second));
    }
}
