package ru.nsu.fit.mustakov.graphics;

import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.geom.PathIterator;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

public class Pixel implements Shape {
    private Rectangle rectangle;

    public Pixel(int x, int y) {
        rectangle = new Rectangle(x, y, 1, 1);
    }

    public Pixel(double x, double y) {
        this((int)x, (int)y);
    }
    
    public Pixel(Point2D point) {
        this(point.getX(), point.getY());
    }

    @Override
    public Rectangle getBounds() {
        return rectangle;
    }

    @Override
    public Rectangle2D getBounds2D() {
        return rectangle;
    }

    @Override
    public boolean contains(double x, double y) {
        return rectangle.contains(x, y);
    }

    @Override
    public boolean contains(Point2D p) {
        return rectangle.contains(p);
    }

    @Override
    public boolean intersects(double x, double y, double w, double h) {
        return rectangle.intersects(x, y, w, h);
    }

    @Override
    public boolean intersects(Rectangle2D r) {
        return rectangle.intersects(r);
    }

    @Override
    public boolean contains(double x, double y, double w, double h) {
        return rectangle.contains(x, y, w, h);
    }

    @Override
    public boolean contains(Rectangle2D r) {
        return rectangle.contains(r);
    }

    @Override
    public PathIterator getPathIterator(AffineTransform at) {
        return rectangle.getPathIterator(at);
    }

    @Override
    public PathIterator getPathIterator(AffineTransform at, double flatness) {
        return rectangle.getPathIterator(at, flatness);
    }
}
